#include "HierarchyInterface.h"

//#include <windows.h>

namespace GtpVisibility {

//-----------------------------------------------------------------------
HierarchyInterface::HierarchyInterface(): 
mFrameId(1), mNumSceneNodes(0), mNumTraversedNodes(0), 
mNumRenderedNodes(0), mSceneRoot(0), mCurrentTestIdx(0)
{	
	mDistanceQueue = new DistanceQueue(GreaterDistance<HierarchyNode *>(this));
}
//-----------------------------------------------------------------------
HierarchyInterface::~HierarchyInterface()
{		
	delete mDistanceQueue;
}
//-----------------------------------------------------------------------
void HierarchyInterface::SetSceneRoot(HierarchyNode *root)
{
	mSceneRoot = root;
}
//-----------------------------------------------------------------------
void HierarchyInterface::InitFrame(HierarchyNode *root)
{
	mFrameId = 0;
	mNumTraversedNodes = 0;
	mNumRenderedNodes = 0;

	SetSceneRoot(root);
	mDistanceQueue->push(mSceneRoot);
}
//-----------------------------------------------------------------------
int HierarchyInterface::GetFrameId()
{
	return mFrameId;
}
//-----------------------------------------------------------------------
DistanceQueue *HierarchyInterface::GetQueue()
{
	return mDistanceQueue;
}
} // namespace GtpVisibility
